jQuery(document).ready(function($) {

    /***** Uploading images *****/

    var file_frame;

    jQuery.fn.uploadMediaFile = function( button, preview_media ) {
        var button_id = button.attr('id');
        var field_id = button_id.replace( '_button', '' );
        var preview_id = button_id.replace( '_button', '_preview' );

        // If the media frame already exists, reopen it.
        if ( file_frame ) {
          file_frame.open();
          return;
        }

        // Create the media frame.
        file_frame = wp.media.frames.file_frame = wp.media({
          title: jQuery( this ).data( 'uploader_title' ),
          button: {
            text: jQuery( this ).data( 'uploader_button_text' ),
          },
          multiple: false
        });

        // When an image is selected, run a callback.
        file_frame.on( 'select', function() {
          attachment = file_frame.state().get('selection').first().toJSON();
          jQuery("#"+field_id).val(attachment.id);
          if( preview_media ) {
            jQuery("#"+preview_id).attr('src',attachment.sizes.thumbnail.url);
          }
          file_frame = false;
        });

        // Finally, open the modal
        file_frame.open();
    }

    jQuery('.image_upload_button').click(function() {
        jQuery.fn.uploadMediaFile( jQuery(this), true );
    });

    jQuery('.image_delete_button').click(function() {
        jQuery(this).closest('td').find( '.image_data_field' ).val( '' );
        jQuery(this).closest('td').find( '.image_preview' ).remove();
        return false;
    });


    /***** VenYou Data Import *****/
    /**
     * @todo Remove all console logging before going into production!
     */
    $('#vy_resources').html( '<div class="rtype"><div class="loading">Loading VenYou data...</div></div>' );
    $.post(
        ajaxurl,
        {
            'action': 'bt_vy_import',
            'data': ''
        },
        function (response) {
            // set html of resources div
            $('#vy_resources').html( response );
            // make sure all checked items have details visible
            vy_checked_rtypes();
            // on click/touch a checkbox...
            $('#vy_resources .rtype input[type=checkbox]').on('click touch', function(e) {
                //console.dir(e);
                console.log('clicked ID ' + e.target.value + ' which has checked value of ' + e.target.checked);
                // update the compiled data in the hidden field which gets saved to options table
                vy_checked_rtypes();
            });
            // on click/touch a debug trigger...
            $('#vy_resources .debug-trigger').on('click touch', function(e) {
                //console.dir(e.target);
                $(e.target).next('.debug').toggle();
            });
            // on change an rtype data element...
            $('#vy_resources .rtype_details input').on('change', function(e) {
                //console.dir(e.target);
                var eData = $(e.target).data();
                //console.dir(eData);
                console.log('rtype is ' + eData.rtypeId + ', you just changed ' + eData.fieldSlug + ' to ' + e.target.value);

                // get current json data for this rtype
                var JSONtextarea = $('textarea.vy_cpt_data-' + eData.rtypeId);
                var rtypeJSON = JSON.parse( JSONtextarea.val() );
                // update the current field if exists, and make sure field slugs with depth (e.g. options) get handled
                var fieldSlug = eData.fieldSlug.replace(/-VY-/g, '.');
                if (typeof eval('rtypeJSON.' + fieldSlug) != 'undefined') {
                    eval('rtypeJSON.' + fieldSlug + ' = e.target.value');
                    // save the updated data into the textarea used to store this rtype's data
                    JSONtextarea.val( JSON.stringify( rtypeJSON ) );
                    // update the compiled data in the hidden field which gets saved to options table
                    vy_checked_rtypes();
                }
            });
        }
    );

    function vy_checked_rtypes() {
        var allVals = [];
        var allData = {};
        // close all details for now
        $('#vy_resources .rtype input[type=checkbox]').each(function() {
            $('#rtype-' + $(this).val() + ' .rtype_details').toggle(false);
        });
        // for all checked items, add val to list, add json to all data and open details
        $('#vy_resources :checked').each(function() {
            allVals.push($(this).val());
            allData[$(this).val()] = JSON.parse( $('#vy_resources .vy_cpt_data-' + $(this).val()).val() );
            $('#rtype-' + $(this).val() + ' .rtype_details').toggle(true);
        });
        // set val of hidden settings field for rtypes to import that goes in database via settings API
        console.log('Checked rtypes are: ' + allVals + '. All CPT data are:');
        console.dir(allData);
        $('#vy_rtypes_to_import').val( encodeURIComponent(JSON.stringify( allData )) );
    }

});