<?php
/*
 * Plugin Name: VenYou Importer
 * Version: 2.1.2
 * Plugin URI: https://bicycletheory.com/
 * Description: Import content types and content from VenYou.
 * Author: Jeremy Burgeson
 * Author URI: https://bicycletheory.com/
 * Requires at least: 4.0
 * Tested up to: 5.2.4
 *
 * Text Domain: venyou-importer
 * Domain Path: /lang/
 *
 * @package WordPress
 * @author Jeremy Burgeson
 * @since 0.1.0
 */

if ( ! defined( 'ABSPATH' ) ) exit;

// define constants
if ( !defined( 'VENYOU_IMPORTER_VERSION' ) ) define( 'VENYOU_IMPORTER_VERSION', '2.1.2' );
if ( !defined( 'YOUTUBE_API_KEY' ) ) define('YOUTUBE_API_KEY', 'AIzaSyCcDF91F4sWZo5EQYhoLSDW6DubxMJE4sc');

// Load plugin class files
require_once( 'includes/class-venyou-importer.php' );
require_once( 'includes/class-venyou-importer-settings.php' );

// Load plugin libraries
require_once( 'includes/lib/class-venyou-importer-admin-api.php' );
require_once( 'includes/lib/class-venyou-importer-post-type.php' );
require_once( 'includes/lib/class-venyou-importer-taxonomy.php' );

/**
 * Returns the main instance of VenYou_Importer to prevent the need to use globals.
 *
 * @since  2.0.0
 * @return object VenYou_Importer
 */
function VenYou_Importer () {
	$instance = VenYou_Importer::instance( __FILE__, VENYOU_IMPORTER_VERSION );

	if ( is_null( $instance->settings ) ) {
		$instance->settings = VenYou_Importer_Settings::instance( $instance );
	}

	return $instance;
}

VenYou_Importer();
